Index: trunk/source/Lib/TLibCommon/TComUpsampleFilter.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 230)
+++ trunk/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 310)
@@ -4,16 +4,6 @@
 
 #if SVC_UPSAMPLING
-// ====================================================================================================================
-// Tables:
-// 1. PHASE_DERIVATION_IN_INTEGER = 0 is the implementation using 2 multi-phase (12 phase and 8 phase) filter sets 
-//    by following K0378.
-// 2. PHASE_DERIVATION_IN_INTEGER = 1 is the implemetation using a 16-phase filter set just for speed up. Some phases 
-//    is approximated to x/16 (e.g. 1/3 -> 5/16). 
-// 3. It was confirmed that two implementations provides the identical result. 
-// 4. By default, PHASE_DERIVATION_IN_INTEGER is set to 1. 
-// ====================================================================================================================
 #define CNU -1 ///< Coefficients Not Used
 
-#if PHASE_DERIVATION_IN_INTEGER
 const Int TComUpsampleFilter::m_lumaFixedFilter[16][NTAPS_US_LUMA] =
 {
@@ -74,49 +64,4 @@
 #endif
 };
-#else
-const Int TComUpsampleFilter::m_lumaFixedFilter[12][NTAPS_US_LUMA] =
-{
-  { 0,  0,   0, 64,  0,   0, 0,  0},
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//1/12 
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//2/12 
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//3/12 
-  { -1, 4, -11, 52, 26,  -8, 3, -1},//4/12 
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//5/12 
-  { -1, 4, -11, 40, 40, -11, 4, -1},//6/12       
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//7/12 
-  { -1, 3,  -8, 26, 52, -11, 4, -1},//8/12 
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//9/12 
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//10/12
-  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//11/12
-};
-
-const Int TComUpsampleFilter::m_chromaFixedFilter15[12][NTAPS_US_CHROMA] =
-{
-  {  0, 64,  0,  0},
-  {CNU,CNU,CNU,CNU},//1/12 
-  {CNU,CNU,CNU,CNU},//2/12 
-  { -4, 54, 16, -2},//3/12 
-  { -5, 50, 22, -3},//4/12 
-  {CNU,CNU,CNU,CNU},//5/12 
-  {CNU,CNU,CNU,CNU},//6/12 
-  { -4, 30, 43, -5},//7/12 
-  { -3, 22, 50, -5},//8/12 
-  {CNU,CNU,CNU,CNU},//9/12 
-  {CNU,CNU,CNU,CNU},//10/12
-  { -1,  5, 62, -2} //11/12
-};
-
-const Int TComUpsampleFilter::m_chromaFixedFilter20[8][NTAPS_US_CHROMA] =
-{
-  {  0, 64,  0,  0},
-  {CNU,CNU,CNU,CNU},//1/8 
-  {CNU,CNU,CNU,CNU},//2/8 
-  { -6, 46, 28, -4},//3/8 
-  { -4, 36, 36, -4},//4/8 
-  {CNU,CNU,CNU,CNU},//5/8 
-  {CNU,CNU,CNU,CNU},//6/8 
-  { -2, 10, 58, -2},//7/8 
-};
-#endif
 
 TComUpsampleFilter::TComUpsampleFilter(void)
@@ -129,7 +74,7 @@
 
 #if SCALED_REF_LAYER_OFFSETS
-Void TComUpsampleFilter::upsampleBasePic( TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Window window )
-#else
-Void TComUpsampleFilter::upsampleBasePic( TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
+Void TComUpsampleFilter::upsampleBasePic( UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Window window )
+#else
+Void TComUpsampleFilter::upsampleBasePic( UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
 #endif
 {
@@ -165,50 +110,30 @@
   Pel* piSrcBufY  = pcBasePic->getLumaAddr();
   Pel* piDstBufY  = pcUsPic->getLumaAddr();
-  
+
   Pel* piSrcY;
   Pel* piDstY;
-  
+
   Pel* piTempBufU = pcTempPic->getCbAddr();
   Pel* piSrcBufU  = pcBasePic->getCbAddr();
   Pel* piDstBufU  = pcUsPic->getCbAddr();
-  
+
   Pel* piTempBufV = pcTempPic->getCrAddr();
   Pel* piSrcBufV  = pcBasePic->getCrAddr();
   Pel* piDstBufV  = pcUsPic->getCrAddr();
-  
+
   Pel* piSrcU;
   Pel* piDstU;
   Pel* piSrcV;
   Pel* piDstV;
-  
-#if JCTVC_L0178
-  Pel *tempBufRight = NULL, *tempBufBottom = NULL;
-  Int tempBufSizeRight = 0, tempBufSizeBottom = 0;
-  
-  if( confBL.getWindowRightOffset())
-  {
-    tempBufSizeRight = confBL.getWindowRightOffset() * pcBasePic->getHeight();
-  }
-  
-  if( confBL.getWindowBottomOffset() )
-  {
-    tempBufSizeBottom = confBL.getWindowBottomOffset() * pcBasePic->getWidth ();
-  }
-  
-  if( tempBufSizeRight )
-  {
-    tempBufRight = (Pel *) xMalloc(Pel, tempBufSizeRight + (tempBufSizeRight>>1) );
-    assert( tempBufRight );
-  }
-  
-  if( tempBufSizeBottom )
-  {
-    tempBufBottom = (Pel *) xMalloc(Pel, tempBufSizeBottom + (tempBufSizeBottom>>1) );
-    assert( tempBufBottom );
-  }
- 
-#endif
-
-  if( widthEL == widthBL && heightEL == heightBL )
+
+#if SIMPLIFIED_MV_POS_SCALING
+  Int scaleX = g_posScalingFactor[refLayerIdc][0];
+  Int scaleY = g_posScalingFactor[refLayerIdc][1];
+#else
+  Int   scaleX     = ( ( widthBL << shiftX ) + ( widthEL >> 1 ) ) / widthEL;
+  Int   scaleY     = ( ( heightBL << shiftY ) + ( heightEL >> 1 ) ) / heightEL;
+#endif
+
+  if( scaleX == 65536 && scaleY == 65536 ) // ratio 1x
   {
     piSrcY = piSrcBufY - scalEL.getWindowLeftOffset() - scalEL.getWindowTopOffset() * strideEL;
